require("postshader")
require("light")




function love.load()
	-- World for light engine
	lightWorld = love.light.newWorld()

	-- Bind window width and height to simpler variables
	width, height = love.window.getWidth(), love.window.getHeight()

	mouseLight = lightWorld.newLight(0, 0, 255, 255, 255, 500) -- Create light
	mouseLight.setSmooth(2) -- Smooth light

	box = lightWorld.newRectangle(400, 300, 50, 100) -- Create test box

	translate = false -- Whether to translate or not
end




function love.update(dt)
	if love.keyboard.isDown("k") then -- Translate by holding k
		translate = true
	else
		translate = false
	end

	lightWorld.update(dt) -- Update light world

	mouseLight.setPosition(love.mouse.getX(), love.mouse.getY(), 0) -- Set the light to mouse position
end




function love.draw()
	love.graphics.push()


	if translate == true then
		love.graphics.translate(10, 10)
		lightWorld.setTranslation(10, 10)
	else
		love.graphics.translate(0, 0)
		lightWorld.setTranslation(0, 0)
	end

	love.graphics.setColor(255, 255, 255)
    love.graphics.rectangle("fill", 0, 0, width, height) -- Draw the background 
	
	lightWorld.drawShadow()

    love.graphics.polygon("fill", box.getPoints()) -- Draw the test box
	
	lightWorld.drawShine()

	love.graphics.pop()


	love.graphics.setColor(0, 0, 0)
	love.graphics.print("Translate by pressing [k]", 15, 15)
	love.graphics.print("Translation: " .. tostring(translate), 15, 40)
end




function love.keyreleased(k)
	if k == "escape" then
		love.event.quit() -- Quit when escape is released
	end
end